    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %                              %
    % Differential Fault Analysis  %
    %                              %
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
addpath(genpath('./AES'));

key_hex = {'00' '11' '22' '33' '44' '55' '66' '77' '88' '99' 'aa' 'bb' 'cc' 'dd' 'ee' 'ff'};

plaintext_hex = {'00' '11' '22' '33' '44' '55' '66' '77' '88' '99' 'aa' 'bb' 'cc' 'dd' 'ee' 'ff'};

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PART 1: FAULT INJECTION SIMULATION
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[s_box, inv_s_box, w, poly_mat, inv_poly_mat] = aes_init(key_hex);

plaintext = hex2dec (plaintext_hex);

% AES ALTERATION
% The given AES encryption has been altered so that it can simulate the
% injection of fault that would result in a bit flip.

% In order to use it:
%
%   Set the 6th attribute to the value of the -byte- you want to attack
%   (0 for correct run, 1 for fault on the 1st byte and so on...)

byte_to_attack = ???;

%
%   Set the 7th attribute to the value of the -bit- you want to attack
%   (0 for correct run, 1 for fault on the 1st bit and so on...)

bit_to_attack = [???]; %%bit_to_attack = randi(???,???,???);

% Run correct AES
c = cipher (plaintext, w, s_box, poly_mat,byte_to_attack,0); 

% Run faulty AES 1
fc_1 = cipher (plaintext, w, s_box, poly_mat,???,???);

% Run faulty AES 2
fc_2 = cipher (plaintext, w, s_box, poly_mat,???,???);

% Run faulty AES 3
fc_3 = cipher (plaintext, w, s_box, poly_mat,???,???);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PART 2: DIFFERENTIAL FAULT ANALYSIS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Run bitDFA
%key_byte = better_bitDFA(c,fc_1,fc_2,fc_3,byte_to_attack)

% Create 3 solution sets (as vectors)
solution_1=[];
solution_2=[];
solution_3=[];

% Generation of the sbox and invert sbox for calculations
[s_box, inv_s_box] = s_box_gen (1);

% Calculate the differences of the correct ciphertext and each faulty ciphertext
diff_1=???;
diff_2=???;
diff_3=???;

% We don't know which bit of byte_to_attack the fault was injected into
% We need to try every possible bit flip (e) on any possible byte value (x)
% First, create the appropriate masking to simulate every possible bitflip 

% For every possible correct byte value, derive its sub_bytes
% For every possible faulty byte value, derive its sub_bytes
% Calculate their difference

% If sbox_diff matches any diff_, put the byte value in the corresponding solution_ set

for r = ???
    e=???
    for x = ???

        corr_sbox=sub_bytes(x, s_box);
        faulty_sbox=sub_bytes(???, s_box);

        sbox_diff=???(corr_sbox,faulty_sbox); % This is the hypothesis

        if ???                         % If the sbox_diff hypothesis match the actual difference diff_1
            solution_1=[solution_1,x]; % Append x to solution_1. Similar for the following conditions
        elseif ???
            solution_2=[solution_2,x];
        elseif ???
            solution_3=[solution_3,x];
        end 

    end
end

% Create the common solution set
solution=[];

% Iterate on the solution_ sets to find matching values
% If a value appears in all three sets, put it in the common solution set
for m=1 : length(solution_1)
    for n=1 : length(solution_2)
        if ???
            for k =1 : length(solution_3)
                if ???
                    ???
                end
            end
        end    
    end
end

% Calculation of the 10th round AES-128 key
% The 10th round consists of:
%   sub_bytes
%   shift_rows, with no effect on 1st row of the state
%   add_round_key, as mix_columns is skipped for the last round of AES

% So, in order to retrieve the byte of the 10th round key, execute the
% operations of sub_bytes for the solution 
% and add_round_key (XOR) for that result and the correct ciphertext byte

% Note : The solution should be unique

if length(solution)==1
RoundKey_10=???(c(byte_to_attack),sub_bytes(solution,s_box));
elseif length(solution)>1
    disp("More than one possible values found");
    RoundKey_10=solution;
else 
    disp("No matching values found");
    RoundKey_10=solution;
end



